/* lanceur.c */
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#include <sys/stat.h>

void
set_uid (const char * fichier)
{
  struct stat etat;
  char *      executable;
  char *      blanc;
  /* Copie du nom du fichier pour pouvoir le modifier */
  if ((executable = (char *) malloc (strlen
				     (fichier) + 1)) == NULL) {
    syslog (LOG_ERR, "Mmoire manquante");
    exit (1);
  }
  strcpy (executable, fichier);
  /* Remplacement du premier blanc ou tabulation par un \0 */
  /* Ceci permet de supprimer les ventuels arguments */
  blanc = strchr (executable, ' ');
  if (blanc != NULL)
    blanc [0] = '\0';
  blanc = strchr (executable, '\t');
  if (blanc != NULL)
    blanc [0] = '\0';
  /* Lecture des informations concernant le fichier */
  if (stat (executable, & etat) != 0) {
    free (executable);
    syslog (LOG_ERR, "Fichier %s inaccessible",
	    executable);
    exit (1);
  }
  free (executable);
  /* On fixe les UID/GID effectifs et rels */
  setregid (etat . st_gid, etat . st_gid);    
  setreuid (etat . st_uid, etat . st_uid);
}

int
main (int argc, char * argv [])
{
  openlog (argv [0], 0, LOG_USER);

  if (argc != 2) {
    syslog (LOG_ERR, "Syntaxe : %s commande", argv [0]);
    exit (1);
  }

  /* Utilisation des UID et GID du fichier excutable */
  set_uid (argv [1]);

  /* Lancement du programme */
  system (argv [1]);
  return (0);
}
